//+------------------------------------------------------------------+
//|                                SoftFractalsStrategyModel_1_3.mq4 |
//|                                                    .. |
//+------------------------------------------------------------------+
// 
//+------------------------------------------------------------------+
#property copyright " .."
#property indicator_chart_window
#property indicator_buffers 4
//---- buffers
double HighHF[], LowHF[], HighLF[], LowLF[];
//---- parameters
// Hight Frequency: 
#property indicator_color1 Red  //   
#property indicator_color2 Green //   
#property indicator_width1 1    //   
#property indicator_width2 1    //   
extern bool StrongLeftHF=false, //   
            StrongRightHF=false,//   
            RepeatHF=true,      //  / 
            ByCloseHF=false,    //    
            SignalsHF=false;    //  ,   
bool NotFirstStartHF, Ban1HF, Ban2HF;
extern int BarsBeforeHF=2,      //    
           BarsAfterHF=1,       //    
           ArrowHF=163;         //   /
// Low Frequency: 
#property indicator_color3 Yellow //   
#property indicator_color4 PaleTurquoise //   
#property indicator_width3 3    //   
#property indicator_width4 3    //   
extern bool StrongLeftLF=false, //   
            StrongRightLF=false,//   
            RepeatLF=true,      //  / 
            ByCloseLF=false,    //    
            SignalsLF=false;    //  ,   
bool NotFirstStartLF, Ban1LF, Ban2LF;
extern int BarsBeforeLF=6,      //    
           BarsAfterLF=2,       //    
           ArrowLF=163;         //   /
//  :
extern bool ClearAtFinish=true; //    
extern color Bear123Color=Pink, //   
             Bull123Color=PaleGreen; //   
extern int OrderLevelStyle=STYLE_DASH, //   
           PositionLevelWidth=3; //    
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, ArrowHF);
   SetIndexBuffer(0, HighHF);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, ArrowHF);
   SetIndexBuffer(1, LowHF);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, ArrowLF);
   SetIndexBuffer(2, HighLF);
   SetIndexEmptyValue(2, 0.0);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, ArrowLF);
   SetIndexBuffer(3, LowLF);
   SetIndexEmptyValue(3, 0.0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("SFSM");
   if( SignalsHF )
     {
      SetIndexLabel(0, "Sell_HF");
      SetIndexLabel(1, "Buy_HF");
     }
   else
     {
      SetIndexLabel(0, "High_HF");
      SetIndexLabel(1, "Low_HF");
     }
   if( SignalsLF )
     {
      SetIndexLabel(2, "Sell_LF");
      SetIndexLabel(3, "Buy_LF");
     }
   else
     {
      SetIndexLabel(2, "High_LF");
      SetIndexLabel(3, "Low_LF");
     }
//      : 
   NotFirstStartHF=false;
   Ban1HF=false;
   Ban2HF=false;
   if( BarsBeforeHF<1 ) BarsBeforeHF=1;
   if( BarsAfterHF<1 ) BarsAfterHF=1;
   NotFirstStartLF=false;
   Ban1LF=false;
   Ban2LF=false;
   if( BarsBeforeLF<BarsBeforeHF ) BarsBeforeLF=BarsBeforeHF;
   if( BarsAfterLF<BarsAfterHF ) BarsAfterLF=BarsAfterHF;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if( ClearAtFinish ) ClearScreen(); //   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if( !NewBar() ) return(0);
   double R, C[];
   int dim, i, j, k=0, D, BarsBefore, BarsAfter;
   bool ByClose, StrongLeft, StrongRight, Repeat,
        Signals, NotFirstStart, Ban1, Ban2;
   while( k<2 )                                 //  HF  LF
     {
      if( k==0 )
        {
         StrongLeft=StrongLeftHF;
         StrongRight=StrongRightHF;
         Repeat=RepeatHF;
         NotFirstStart=NotFirstStartHF;
         Ban1=Ban1HF;
         Ban2=Ban2HF;
         BarsBefore=BarsBeforeHF;
         BarsAfter=BarsAfterHF;
         Signals=SignalsHF;
         ByClose=ByCloseHF;
        }
      else
        {
         StrongLeft=StrongLeftLF;
         StrongRight=StrongRightLF;
         Repeat=RepeatLF;
         NotFirstStart=NotFirstStartLF;
         Ban1=Ban1LF;
         Ban2=Ban2LF;
         BarsBefore=BarsBeforeLF;
         BarsAfter=BarsAfterLF;
         Signals=SignalsLF;
         ByClose=ByCloseLF;
        }
      dim=ArrayResize(C, BarsBefore+1+BarsAfter);
      if( NotFirstStart ) i=BarsAfter+1; else i=Bars-BarsBefore-1;
//----  
      while( i > BarsAfter )
        {
         j=0;
         if( ByClose )
           {
            while ( j < dim ) { C[j]=Close[j+i-BarsAfter]; j++; }
            if( MathAbs(C[BarsAfter+1]-C[BarsAfter]) < Point
             && MathAbs(C[BarsAfter-1]-C[BarsAfter]) < Point )
              { i--; continue; }                //  
            if( C[BarsAfter+1] > C[BarsAfter] )
               if( C[BarsAfter] <= C[BarsAfter-1] )
                 { D=-1; R=C[BarsAfter]; }      //  
               else { i--; continue; }          //  
            else
               if( C[BarsAfter] >= C[BarsAfter-1] )
                 { D=1; R=C[BarsAfter]; }       //  
               else { i--; continue; }          //  
            j=1;
            while ( j < dim )
              {
               if( D > 0 )                      //  ?
               if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
                || ( j < BarsAfter && C[j-1] > R && !StrongRight )
                || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
                || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
                 { D=0; break; }                //  
               if( D < 0 )                      //  ?
               if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
                || ( j < BarsAfter && C[j-1] < R && !StrongRight )
                || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
                || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
                 { D=0; break; }                //  
               j++;
              }
            if( D == 0 ) { i--; continue; }     //  
            if( Signals )
              {
               j=i-BarsAfter-1;                 //  
               R=Open[j];                       //  
              }
            else j=i;                           //  
            //         :
            if( D>0 && !Ban1 )
              {
               if( k==0 ) HighHF[j]=R; else HighLF[j]=R;
               if( !Repeat ) { Ban1=true; Ban2=false; }
              }
            else if( D<0 && !Ban2 )
              {
               if( k==0 ) LowHF[j]=R; else LowLF[j]=R;
               if( !Repeat ) { Ban1=false; Ban2=true; }
              }
           }
         else
           {
            R=0;
            while ( j < dim ) { C[j]=High[j+i-BarsAfter]; j++; }
            if( C[BarsAfter+1] < C[BarsAfter] && C[BarsAfter] >= C[BarsAfter-1] )
              {
               R=C[BarsAfter];                  //  
               j=1;
               while ( j < dim )
                 {
                  if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
                   || ( j < BarsAfter && C[j-1] > R && !StrongRight )
                   || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
                   || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
                    { R=0; break; }             //  
                  j++;
                 }
              }
            if( R >= Point )
              {
               if( Signals )
                 {
                  j=i-BarsAfter-1;              //  
                  R=Open[j];                    //  
                 }
               else j=i;                        //  
               if( !Ban1 )
                 {   //         
                  if( k==0 ) HighHF[j]=R; else HighLF[j]=R;
                  if( !Repeat ) { Ban1=true; Ban2=false; }
                 }
              }
            R=0;
            j=0;
            while ( j < dim ) { C[j]=Low[j+i-BarsAfter]; j++; }
            if( C[BarsAfter+1] > C[BarsAfter] && C[BarsAfter] <= C[BarsAfter-1] )
              {
               R=C[BarsAfter];                  //  
               j=1;
               while ( j < dim )
                 {
                  if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
                   || ( j < BarsAfter && C[j-1] < R && !StrongRight )
                   || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
                   || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
                    { R=0; break; }             //  
                  j++;
                 }
              }
            if( R >= Point )
              {
               if( Signals )
                 {
                  j=i-BarsAfter-1;              //  
                  R=Open[j];                    //  
                 }
               else j=i;                        //  
               if( !Ban2 )
                 {   //         
                  if( k==0 ) LowHF[j]=R; else LowLF[j]=R;
                  if( !Repeat ) { Ban1=false; Ban2=true; }
                 }
              }
           }
         i--;
        }
      if( !NotFirstStart ) NotFirstStart=true;
      if( k==0 )
        {
         NotFirstStartHF=NotFirstStart;
         Ban1HF=Ban1;
         Ban2HF=Ban2;
        }
      else
        {
         NotFirstStartLF=NotFirstStart;
         Ban1LF=Ban1;
         Ban2LF=Ban2;
        }
      k++;
     }                                          //  
   ClearScreen();                               //   
   FindPatterns();                              //    
//----
   WindowRedraw();                              //  
   return(0);
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void ClearScreen()
  {
//----
   string Pref1="Pattern",
          Pref2="Order";
   for(int k=ObjectsTotal()-1; k>=0; k--)
     {
      string Obj_Name=ObjectName(k);
      string Head1=StringSubstr(Obj_Name,0,StringLen(Pref1));
      string Head2=StringSubstr(Obj_Name,0,StringLen(Pref2));
      if ( Head1==Pref1 || Head2==Pref2 ) ObjectDelete(Obj_Name);
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|   1-2-3
//+------------------------------------------------------------------+
void Paint.123(datetime Time0,datetime Time1,datetime Time2,double Price1,
               double Price2,color Color,int Width,int Number,string Order)
  {
//----
   string Name="Pattern #"+Number,
          Text;
   color PatternColor;
   bool Result=ObjectCreate(Name,OBJ_RECTANGLE,0,Time1,Price1,Time2,Price2);
   if( Price2>Price1 )
     {
      Text="   Bull 123 #";
      PatternColor=Bull123Color;
     }
   else
     {
      Text="   Bear 123 #";
      PatternColor=Bear123Color;
     }
   Text=Text+Number;
   Result=Result && ObjectSetText(Name,Text);
   Result=Result && ObjectSet(Name,OBJPROP_COLOR,PatternColor);
   Name="Order #"+Number;
   Result=ObjectCreate(Name,OBJ_TREND,0,Time2,Price2,Time0,Price2);
   Text=Order+Number;
   Result=Result && ObjectSetText(Name,Text);
   Result=Result && ObjectSet(Name,OBJPROP_RAY,false);
   Result=Result && ObjectSet(Name,OBJPROP_COLOR,Color);
   Result=Result && ObjectSet(Name,OBJPROP_WIDTH,Width);
   if( Width<2 ) Result=Result && ObjectSet(Name,OBJPROP_STYLE,OrderLevelStyle);
//----
   return;
  }
//+------------------------------------------------------------------+
//|    1-2-3
//+------------------------------------------------------------------+
void Bear.123(int Bar1, int Bar2,int& Number)
  {
//----
   string Order=" Sell Stop #";
   double Price1=HighLF[Bar1],                  //   () 
          Price2=LowHF[Bar2];                   //   () 
   datetime Time1=Time[Bar1],                   //   () 
            Time2=Time[Bar2];                   //   () 
   int Bar0=Bar2-1;                             //   
   while( Bar0>0 )
     {
      if( Low[Bar0]<Price2 ) break;             //  
      if( High[Bar0]>Price1 )
        {                                       //  
         Number--;
         return;
        }
      Bar0--;
     }
   datetime Time0=Time[Bar0];                   //   
   color Color;                                 //    
   int Width;                                   //    
   if( Bar0==0 )
     {                                          //   
      Color=indicator_color2;
      Width=indicator_width1;
     }
   else
     {                                          //  
      Color=indicator_color1;
      Width=PositionLevelWidth;
     }
   Paint.123(Time0,Time1,Time2,Price1,Price2,Color,Width,Number,Order);
//----
   return;
  }
//+------------------------------------------------------------------+
//|    1-2-3
//+------------------------------------------------------------------+
void Bull.123(int Bar1, int Bar2,int& Number)
  {
//----
   string Order=" Buy Stop #";
   double Price1=LowLF[Bar1],                   //   () 
          Price2=HighHF[Bar2];                  //   () 
   datetime Time1=Time[Bar1],                   //   () 
            Time2=Time[Bar2];                   //   () 
   int Bar0=Bar2-1;                             //   
   while( Bar0>0 )
     {
      if( High[Bar0]>Price2 ) break;            //  
      if( Low[Bar0]<Price1 )
        {                                       //  
         Number--;
         return;
        }
      Bar0--;
     }
   datetime Time0=Time[Bar0];                   //   
   color Color;                                 //    
   int Width;                                   //    
   if( Bar0==0 )
     {                                          //   
      Color=indicator_color1;
      Width=indicator_width1;
     }
   else
     {                                          //  
      Color=indicator_color2;
      Width=PositionLevelWidth;
     }
   Paint.123(Time0,Time1,Time2,Price1,Price2,Color,Width,Number,Order);
//----
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void FindPatterns()
  {
//----
   int Number,                                  //  
       Bar1,                                    //    
       Bar2=BarsAfterHF+1,                      //    
       Out=Bars-BarsBeforeHF;                   //    
   while( Bar2<Out )
     {
      if( HighLF[Bar2]<Point && LowLF[Bar2]<Point ) //   LF 
         if( HighHF[Bar2]>Point && LowHF[Bar2]<Point )
           {                                    //  HighHF 
            Bar1=Bar2+1;
            while( Bar1<Out )
              {
               if( HighLF[Bar1]>Point || HighHF[Bar1]>Point ) break;
               if( LowLF[Bar1]>Point )
                 {                              //  
                  Number++;
                  Bull.123(Bar1,Bar2,Number);
                  break;
                 }
               Bar1++;
              }
           }
         else if( HighHF[Bar2]<Point && LowHF[Bar2]>Point )
           {                                    //  LowHF 
            Bar1=Bar2+1;
            while( Bar1<Out )
              {
               if( LowLF[Bar1]>Point || LowHF[Bar1]>Point ) break;
               if( HighLF[Bar1]>Point )
                 {                              //  
                  Number++;
                  Bear.123(Bar1,Bar2,Number);
                  break;
                 }
               Bar1++;
              }
           }
      Bar2++;
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
bool NewBar() 
  {
//----
   static datetime NewTime;               //   
   bool NewBar=false;                     //   
   if( NewTime!=Time[0] )
     {
      NewTime=Time[0];                    //   
      NewBar=true;                        //   
     }
//----
   return(NewBar);
  }
//+------------------------------------------------------------------+